-- simple ui for rgmercs
-- pezak 2023



local mq = require('mq')

local MQVAR = mq.TLO.Macro.Variable
local openGUI = true
local shouldDrawGUI = true
local werunning = true
local runstuff = 0
local switchmount = false

local varmode = {}
local dovar = {}

local rgrunning = string.find(mq.TLO.Macro.Name() or '', 'RGMERC.mac')

if rgrunning == nil then rgrunning = false else rgrunning = true end

mq.delay(100)

local function mycombo(variable,command,combostring)
    local varmode = tonumber(tostring(MQVAR(variable..'[2]')))
    if varmode ~= nil then
        ImGui.SetNextItemWidth('40')
        local dovar = ImGui.Combo(variable, varmode+1, combostring)
        local dovar = tonumber(dovar)-1
        if dovar ~= varmode then mq.cmd('/rg '..command..' '..dovar) 
        varmode = dovar end
        --if ImGui.IsItemHovered() then ImGui.SetTooltip(tostring(MQVAR(variable..'[3]'))) end
        ImGui.SameLine() ImGui.HelpMarker(tostring(MQVAR(variable..'[3]')))
        return dovar
    else
        return false
    end
end
local function mytextinput(variable,command,width)
    varmode[variable] = tostring(MQVAR(variable..'[2]'))
    if varmode[variable] ~= nil and varmode[variable] ~= 'NULL' then
        ImGui.Text(variable)
        --if ImGui.IsItemHovered() then ImGui.SetTooltip(tostring(MQVAR(variable..'[3]'))) end
        ImGui.SameLine()
        ImGui.SetNextItemWidth(width)
        dovar[variable] = ImGui.InputText("##varmode["..variable.."]", varmode[variable])
        --if ImGui.IsItemHovered() then ImGui.SetTooltip(tostring(MQVAR(variable..'[3]'))) end
        ImGui.SameLine() ImGui.HelpMarker(tostring(MQVAR(variable..'[3]')))
        if dovar[variable] ~= varmode[variable] then 
            mq.cmd('/rg '..command..' \"'..dovar[variable]..'\"')
            varmode[variable] = dovar[variable] 
            return dovar[variable]
        end
    else
        return false
    end
    return false
end
local function mycheckvar(variable)
    local varmode = tonumber(tostring(MQVAR(variable..'[2]')))
    if varmode ~= nil then
        return true
    else
        return false
    end
end
local function mygroupstart()
    local pcsearch = string.format('pc radius %s targetable zradius %s',120,20)
    local pccount = mq.TLO.SpawnCount(pcsearch)()
    if pccount > 0 then
        for n = 1, pccount do
            local pcname=mq.TLO.NearestSpawn(n, pcsearch).CleanName()
            local pc = mq.TLO.NearestSpawn(n, pcsearch)
            if pcname~=mq.TLO.Me.CleanName() and pc.Guild()==mq.TLO.Me.Guild() then
                mq.cmd('/inv '..pcname)
            end
        end
        mq.delay(2000)
        mq.cmd('/dgz /inv')
        mq.delay(3000)
        mq.cmdf('/grouproles set %s 1',mq.TLO.Me.CleanName())
        mq.cmdf('/grouproles set %s 2',mq.TLO.Me.CleanName())
        mq.cmdf('/grouproles set %s 3',mq.TLO.Me.CleanName())
        print('group started')
    end
end
local function gcom()
    return '/dgaex group_'..mq.TLO.EverQuest.Server()..'_'..mq.TLO.Group.Leader()..' '
end
local function HelpMarker(desc)
    ImGui.TextDisabled('(?)')
    if ImGui.IsItemHovered() then
        ImGui.BeginTooltip()
        ImGui.PushTextWrapPos(ImGui.GetFontSize() * 35.0)
        ImGui.Text(desc)
        ImGui.PopTextWrapPos()
        ImGui.EndTooltip()
    end
end
local RGGUI = function()
    local flags = ImGuiWindowFlags.AlwaysAutoResize or 0
    flags = bit32.bor(flags, ImGuiWindowFlags.NoCollapse)
    openGUI, shouldDrawGUI = ImGui.Begin('RGGUI', openGUI, flags)
    if shouldDrawGUI then
        local pctHPs = mq.TLO.Me.GroupAssistTarget.PctHPs()
        if not pctHPs then pctHPs = 0 end
        local ratioHPs = pctHPs / 100
        if rgrunning == true and switchmount==false then
            ImGui.BeginTabBar('Rgmercs')
            if ImGui.BeginTabItem('Hud') then
                if ImGui.BeginChild('myhud',300,100) then
                    ImGui.Text('DoPull')
                    ImGui.SameLine()
                    for n = 0, 4 do
                        if tonumber(tostring(MQVAR('DoPull[2]')))==n then mybut = string.format('(%d)',n)
                            ImGui.PushStyleColor(ImGuiCol.Button, 0, 1, 0, .3) 
                        else mybut = string.format('%d',n) end
                        if ImGui.SmallButton(mybut) then mq.cmd('/rg dopull '..tostring(n)) end 
                        if tonumber(tostring(MQVAR('DoPull[2]')))==n then ImGui.PopStyleColor() end
                        if n<4 then ImGui.SameLine() end
                    end
                    ImGui.SameLine() ImGui.HelpMarker(tostring(MQVAR('DoPull[3]')))
                    mycombo('ClassMode','classmode','0\0 1\0 2\0 3\0 4\0 5\0\0')
                    ImGui.Text('Assisting >>') ImGui.SameLine()
                    ImGui.PushStyleColor(ImGuiCol.Text, 1, 0, 0, 1)
                    ImGui.Text(tostring(MQVAR('assistname'))) ImGui.SameLine()
                    ImGui.PopStyleColor()
                    ImGui.Text('<< at') ImGui.SameLine()
                    ImGui.PushStyleColor(ImGuiCol.Text, 0, 1, 0, 1)
                    ImGui.Text(tostring(MQVAR('AutoAssistAt[2]'))..'%')
                    ImGui.PopStyleColor()
                    ImGui.EndChild()
                end
                ImGui.EndTabItem()
            end
            if ImGui.BeginTabItem('Overview') then
                if ImGui.BeginChild('Over',300,100) then
                    ImGui.Text('RG Version: '..tostring(MQVAR('RGVersion')))
                    if ImGui.SmallButton('restart RGMercs') then startup = true end
                    ImGui.SameLine()
                    if ImGui.SmallButton('/rggroup') then mq.cmd('/rggroup') end
                    ImGui.SameLine()
                    if ImGui.SmallButton('start a group') then runstuff = 1 end
                    if ImGui.SmallButton('Restart ui') then
                        mq.cmd('/timed 40 /lua run rgui')
                        mq.cmd('/timed 5 /lua stop rgui')            
                    end
                    ImGui.EndChild()
                end
                ImGui.EndTabItem()
            end
            if ImGui.BeginTabItem('Pull') then
                mycombo('DoPull','dopull','0\0 1\0 2\0 3\0 4\0\0')
                mytextinput('PullRad','pullrad',40)
                mytextinput('PullMinLvl','pullminlvl',40)
                mytextinput('PullMaxLvl','pullmaxlvl',40)
                mycombo('GroupWatch','groupwatch','0\0 1\0 2\0\0')
                mycombo('DoPetPull','dopetpull','0\0 1\0\0')
                ImGui.Text('pull abilitytype:'..tostring(MQVAR('Pull_AbilityType'))) ImGui.SameLine()
                ImGui.Text('pull ability:'..tostring(MQVAR('Pull_Ability')))
                ImGui.Text('pull ignore:'..tostring(MQVAR('Ini[${Pull_INI},${Zone.ShortName},MobsToPull]')))
                ImGui.EndTabItem()
            end
            if ImGui.BeginTabItem('Settings') then
                if ImGui.BeginChild('Setting',400,280) then
                ImGui.BeginGroup('prutt')
                if ImGui.TreeNode('Tank Options') then
                    mycombo('DoTank','DoTank','0\0 1\0\0')
                    mycombo('DoTorrent','DoTorrent','0\0 1\0\0')
                    mycombo('DoAeHate','DoAeHate','0\0 1\0\0')
                    mycombo('DoAEAggro','DoAEAggro','0\0 1\0\0')
                    mycombo('DoBattleLeap','DoBattleLeap','0\0 1\0\0')
                    mycombo('DoDefense','DoDefense','0\0 1\0\0')
                    mycombo('DoAutoPDH','DoAutoPDH','0\0 1\0\0')
                    mycombo('SummonArrows','SummonArrows','0\0 1\0\0')
                    mycombo('DoBandolier','DoBandolier','0\0 1\0\0')
                    mytextinput('AeTauntCnt','AeTauntCnt',40)
                    mytextinput('Flashhp','Flashhp',40)
                    ImGui.TreePop()
                end
                if ImGui.TreeNode('Combat Options') then
                    mycombo('DoMelee','domelee','0\0 1\0\0')
                    mycombo('DoOpener','DoOpener','0\0 1\0\0')
                    mycombo('DoHideSneak','DoHideSneak','0\0 1\0\0')
                    mycombo('DoPickPocket','DoPickPocket','0\0 1\0\0')
                    mycombo('DoDoT','DoDoT','0\0 1\0\0')
                    mycombo('DoAmbush','DoAmbush','0\0 1\0\0')
                    mycombo('DoMark','DoMark','0\0 1\0\0')
                    mycombo('DoPinpointBurn','DoPinpointBurn','0\0 1\0\0')
                    mycombo('DoExecBurn','DoExecBurn','0\0 1\0\0')
                    mycombo('DoIntimidation','DoIntimidation','0\0 1\0\0')
                    mycombo('DoIntimidate','DoIntimidate','0\0 1\0\0')
                    mycombo('DoDisarm','DoDisarm','0\0 1\0\0')
                    mycombo('DoAoe','DoAoe','0\0 1\0\0')
                    mycombo('DoPoisonArrow','DoPoisonArrow','0\0 1\0\0')
                    mycombo('DoReagentArrow','DoReagentArrow','0\0 1\0\0')
                    mycombo('DoAgroReducerBuff','DoAgroReducerBuff','0\0 1\0\0')
                    mycombo('DoAoe','DoAoe','0\0 1\0\0')
                    mycombo('DoAE','DoAE','0\0 1\0\0')
                    mycombo('SummonArrows','SummonArrows','0\0 1\0\0')
                    mycombo('UseBattleRez','UseBattleRez','0\0 1\0\0')
                    mycombo('DoAutoTarget','DoAutoTarget','0\0 1\0\0')
                    mycombo('SafeTargeting','SafeTargeting','0\0 1\0\0')
                    mycombo('StayOnTarget','StayOnTarget','0\0 1\0\0')
                    mycombo('DoAutoEngage','DoAutoEngage','0\0 1\0\0')
                    mycombo('FollowMarkTarget','FollowMarkTarget','0\0 1\0\0')
                    mytextinput('Startlifetap','Startlifetap',40)
                    mytextinput('Startbigtap','Startbigtap',40)
                    mytextinput('AssistRange','AssistRange',80)
                    mytextinput('AutoAssistAt','AutoAssistAt',40)
                    mytextinput('PetEngagePct','PetEngagePct',40)
                    mytextinput('AutoCampRadius','AutoCampRadius',80)
                    mycombo('DoEpic','DoEpic','0\0 1\0\0')
                    mycombo('BurnAlways','burnalways','0\0 1\0 2\0 3\0 4\0\0')
                    mytextinput('BurnMobCount','BurnMobCount',40)
                    mycombo('BurnNamed','BurnNamed','0\0 1\0\0')
                    mycombo('BurnAuto','BurnAuto','0\0 1\0\0')
                    mycombo('BurnSize','BurnSize','0\0 1\0 2\0 3\0 4\0 5\0\0')
                    ImGui.TreePop()
                end
                if ImGui.TreeNode('General Options') then
                    mycombo('ClassMode','classmode','0\0 1\0 2\0 3\0 4\0 5\0\0')
                    mycombo('DoHots','dohots','0\0 1\0\0')
                    mycombo('DoHot','dohot','0\0 1\0\0')
                    mycombo('FetchCorpse','FetchCorpse','0\0 1\0\0')
                    mycombo('DoBattleRez','dobattlerez','0\0 1\0\0')
                    mycombo('DoReverseDS','DoReverseDS','0\0 1\0\0')
                    mycombo('DoModRod','domodrod','0\0 1\0\0')
                    if mycombo('DoMount','domount','0\0 1\0 2\0\0') > 0 then
                        beginmount=tostring(MQVAR('MountItem[2]'))
                        cmount=beginmount
                        local mountflags = ImGuiComboFlags.PopupAlignLeft
                        --local assistsearch = string.format('pc radius %s targetable zradius %s',assistrange,20)
                        local mountcount = mq.TLO.Mount.Count()
                        if mountcount > 0 then
                            if ImGui.BeginCombo("Mount:", cmount, mountflags) then
                            for n = 1, mountcount do
                                local mountname=mq.TLO.Mount(n).Name()
                                --if mountname == cmount then mount_selected = true end
                                local mount_selected = cname == mountname
                                if ImGui.Selectable(mountname, mount_selected) then
                                    --print(mountname)
                                    if mountname~=beginmount then mq.cmd('/rg mountitem \"'..mountname..'\"') end
                                    cmount = mountname
                                    rgrunning = false
                                    switchmount = true
                                end
                                if mount_selected then
                                    ImGui.SetItemDefaultFocus()
                                end
                            end
                            ImGui.EndCombo()
                            end
                        end
    
                    end
                    mytextinput('MaintainCampfire','MaintainCampfire',40)
                    ImGui.TreePop()
                end
                if ImGui.TreeNode('Buffs Options') then
                    mycombo('DoBuffs','dobuffs','0\0 1\0\0')
                    mycombo('DoBrells','DoBrells','0\0 1\0\0')
                    mycombo('DoRunSpeed','DoRunSpeed','0\0 1\0\0')
                    mycombo('DoAura','DoAura','0\0 1\0\0')
                    mycombo('DoPara','DoPara','0\0 1\0\0')
                    mytextinput('ParagonManaPct','ParagonManaPct',40)
                    mycombo('DoLearners','DoLearners','0\0 1\0\0')
                    mycombo('DoHaste','DoHaste','0\0 1\0\0')
                    mycombo('DoStatBuff','DoStatBuff','0\0 1\0\0')
                    mycombo('DoNDTBuff','DoNDTBuff','0\0 1\0\0')
                    mycombo('DoAggroRune','DoAggroRune','0\0 1\0\0')
                    mycombo('DoGroupAbsorb','DoGroupAbsorb','0\0 1\0\0')
                    mycombo('DoTwinCastMez','DoTwinCastMez','0\0 1\0\0')
                    mycombo('DoTwinCastDPS','DoTwinCastDPS','0\0 1\0\0')
                    mycombo('DoQp','DoQp','0\0 1\0\0')
                    mytextinput('QPManaPCT','QPManaPCT',40)
                    mytextinput('VetManaPCT','VetManaPCT',40)
                    mycombo('DivineBuffOn','DivineBuffOn','0\0 1\0\0')
                    mycombo('DoCombatRod','DoCombatRod','0\0 1\0\0')
                    mycombo('SummonModRods','SummonModRods','0\0 1\0\0')
                    mycombo('DoOOWRobe','DoOOWRobe','0\0 1\0\0')
                    mycombo('DoPoison','DoPoison','0\0 1\0\0')
                    mytextinput('PoisonClicky','PoisonClicky',140)
                    mytextinput('PoisonName','PoisonName',140)
                    mytextinput('PoisonBuffName','PoisonBuffName',140)
                    mytextinput('PoisonItemCount','PoisonItemCount',40)
                    mytextinput('ChestItemName','ChestItemName',140)
                    mytextinput('DeathBloomPercent','DeathBloomPercent',40)
                    mycombo('DoLich','DoLich','0\0 1\0\0')
                    mycombo('DeadMansFloating','DeadMansFloating','0\0 1\0\0')
                    mycombo('DoLich','DoLich','0\0 1\0\0')
                    mycombo('SummonAxes','SummonAxes','0\0 1\0\0')
                    mycombo('SummonAxes2','SummonAxes2','0\0 1\0\0')
                    mycombo('SummonDichoAxes','SummonDichoAxes','0\0 1\0\0')
                    mytextinput('AutoAxeCount','AutoAxeCount',40)
                    mytextinput('AutoAxeMin','AutoAxeMin',40)
                    mytextinput('AutoAxe2Count','AutoAxe2Count',40)
                    mytextinput('AutoAxe2Min','AutoAxe2Min',40)
                    mytextinput('DichoAxeCount','DichoAxeCount',40)
                    mytextinput('DichoAxeMin','DichoAxeMin',40)
                    ImGui.TreePop()
                end
                if mycheckvar('DoHeals') and ImGui.TreeNode('Heal Options') then
                    mycombo('DoHeals','doheals','0\0 1\0\0')
                    mytextinput('MainHealPoint','mainhealpoint',40)
                    mytextinput('BigHealPoint','bighealpoint',40)
                    mytextinput('LightHealPoint','LightHealPoint',40)
                    mytextinput('ClutchHealPoint','ClutchHealPoint',40)
                    mytextinput('GroupHealPoint','grouphealpoint',40)
                    mytextinput('RecklessHealPoint','recklesshealpoint',40)
                    mytextinput('TotHealPoint','TotHealPoint',40)
                    mytextinput('GroupInjureCnt','GroupInjureCnt',40)
                    mytextinput('PetHealPoint','pethealpoint',40)
                    mytextinput('PetHealPct','PetHealPct',40)
                    mytextinput('LayHandsPct','LayHandsPct',40)
                    mycombo('DoProm','DoProm','0\0 1\0\0')
                    mycombo('DoClutchHeal','DoClutchHeal','0\0 1\0\0')
                    mycombo('DoAutoWard','DoAutoWard','0\0 1\0\0')
                    mycombo('DoCure','DoCure','0\0 1\0\0')
                    ImGui.TreePop()
                end
                if ImGui.TreeNode('Med Options') then
                    mycombo('DoMed','domed','0\0 1\0 2\0\0')
                    mytextinput('HPMedPct','HPMedPct',40)
                    mytextinput('HPMedPctStop','HPMedPctStop',40)
                    mytextinput('EndMedPct','EndMedPct',40)
                    mytextinput('EndMedPctStop','EndMedPctStop',40)
                    mytextinput('ManaMedPct','ManaMedPct',40)
                    mytextinput('ManaMedPctStop','ManaMedPctStop',40)
                    ImGui.TreePop()
                end
                if mycheckvar('DoNuke') and ImGui.TreeNode('Nuke Options') then
                    mycombo('DoNuke','donuke','0\0 1\0\0')
                    mycombo('DoManaBurn','DoManaBurn','0\0 1\0\0')
                    mycombo('WeaveAANukes','WeaveAANukes','0\0 1\0\0')
                    mycombo('EmergencyEvac','EmergencyEvac','0\0 1\0\0')
                    mycombo('DoMagicNuke','DoMagicNuke','0\0 1\0\0')
                    mycombo('DoFireNuke','DoFireNuke','0\0 1\0\0')
                    mycombo('DoIceNuke','DoIceNuke','0\0 1\0\0')
                    mycombo('DoLure','DoLure','0\0 1\0\0')
                    mycombo('DoRain','DoRain','0\0 1\0\0')
                    mycombo('DoForce','DoForce','0\0 1\0\0')
                    mytextinput('NukeUntilMana','NukeUntilMana',40)
                    mytextinput('HarvestManaPct','HarvestManaPct',40)
                    mytextinput('JoltAtAggro','JoltAtAggro',40)
                    mytextinput('Manatonuke','Manatonuke',40)
                    mytextinput('StopNukeAt','StopNukeAt',40)
                    mytextinput('HPStopDOT','HPStopDOT',40)
                    ImGui.TreePop()
                end
                if mycheckvar('DoAACanni') and ImGui.TreeNode('Canni Options') then
                    mycombo('DoAACanni','DoAACanni','0\0 1\0\0')
                    mytextinput('AACanniManaPct','AACanniManaPct',40)
                    mytextinput('AACanniMinHP','AACanniMinHP',40)
                    mycombo('DoSpellCanni','DoSpellCanni','0\0 1\0\0')
                    mytextinput('CanniManaPct','CanniManaPct',40)
                    mytextinput('CanniMinHP','CanniMinHP',40)
                    ImGui.TreePop()
                end
                if ImGui.TreeNode('Debuffs') then
                    mycombo('DoCharmPet','DoCharmPet','0\0 1\0\0')
                    mycombo('CharmPreStun','CharmPreStun','0\0 1\0\0')
                    mycombo('CharmPreTash','CharmPreTash','0\0 1\0\0')
                    mycombo('CharmMinMobs','CharmMinMobs','0\0 1\0 2\0 3\0 4\0 5\0\0')
                    mycombo('DoDicho','DoDicho','0\0 1\0\0')
                    mycombo('DoDot','DoDot','0\0 1\0\0')
                    mycombo('DoDots','DoDots','0\0 1\0\0')
                    mycombo('DoTash','DoTash','0\0 1\0\0')
                    mycombo('DoSnare','DoSnare','0\0 1\0\0')
                    mycombo('DoAATash','DoAATash','0\0 1\0\0')
                    mycombo('DoMalo','DoMalo','0\0 1\0\0')
                    mycombo('DoAoEMalo','DoAoEMalo','0\0 1\0\0')
                    mycombo('DoSlow','DoSlow','0\0 1\0\0')
                    mycombo('DoAoESlow','DoAoESlow','0\0 1\0\0')
                    mycombo('DoDieaseSlow','DoDieaseSlow','0\0 1\0\0')
                    mycombo('DoMagicDot','DoMagicDot','0\0 1\0\0')
                    mycombo('DoCripple','DoCripple','0\0 1\0\0')
                    mycombo('AutoLevelRange','AutoLevelRange','0\0 1\0\0')
                    mycombo('DoStripBuff','DoStripBuff','0\0 1\0\0')
                    mytextinput('AutoDebuffAt','AutoDebuffAt',40)
                    mytextinput('CharmMinLvl','CharmMinLvl',40)
                    mytextinput('CharmMaxLvl','CharmMaxLvl',40)
                    mytextinput('HPStopDOT','HPStopDOT',40)
                    ImGui.TreePop()
                end
                if mycheckvar('DoPet') and ImGui.TreeNode('Pet Options') then
                    mycombo('DoPet','DoPet','0\0 1\0\0')
                    mycombo('DoSwarmPet','DoSwarmPet','0\0 1\0\0')
                    mycombo('DoPetSlow','DoPetSlow','0\0 1\0\0')
                    mycombo('DoPocketPet','DoPocketPet','0\0 1\0\0')
                    mycombo('DoPetTank','DoPetTank','0\0 1\0\0')
                    mytextinput('PetType','PetType',40)
                    mycombo('DoPetDrain','DoPetDrain','0\0 1\0\0')
                    mycombo('DoGroupToys','DoGroupToys','0\0 1\0\0')
                    mycombo('DoPetArmor','DoPetArmor','0\0 1\0\0')
                    mycombo('DoPetHeirloom','DoPetHeirloom','0\0 1\0\0')
                    ImGui.TreePop()
                end
                if ImGui.TreeNode('Assistoutside Options') then   
                    mycombo('AssistOutside','AssistOutside','0\0 1\0\0')
                    mytextinput('OaList','OaList',180)
                    ImGui.TreePop()
                end     
                ImGui.EndGroup()
                ImGui.EndChild()
            end
                ImGui.EndTabItem()
            end
            if ImGui.BeginTabItem('Group') then
                ImGui.Text('Commands sent to the group')
                if ImGui.SmallButton('Camphere') then mq.cmd(gcom()..'/rg camphere') end
                if ImGui.IsItemHovered() then ImGui.SetTooltip('Set your camp to this location and return after leaving AutoCampRadius.') end
                ImGui.SameLine()
                if ImGui.SmallButton('Camphard') then mq.cmd(gcom()..'/rg camphard') end
                if ImGui.IsItemHovered() then ImGui.SetTooltip('Set your camp to this location and return every time.') end
                ImGui.SameLine()
                if ImGui.SmallButton('Campoff') then mq.cmd(gcom()..'/rg campoff') end
                if ImGui.IsItemHovered() then ImGui.SetTooltip('Turn off ReturnToCamp') end
                ImGui.SameLine()
                if ImGui.SmallButton('Chaseon') then mq.cmd(gcom()..'/rg chaseon') end
                if ImGui.IsItemHovered() then ImGui.SetTooltip('Start chasing your main assist (uses afollow)') end
                ImGui.SameLine()
                if ImGui.SmallButton('Chaseoff') then mq.cmd(gcom()..'/rg chaseoff') end
                if ImGui.IsItemHovered() then ImGui.SetTooltip('Stops chasing') end
                ImGui.EndTabItem()
            end
            ImGui.EndTabBar()
        else
            if ImGui.SmallButton('/rgstart') then 
                startup = true
            end
            if ImGui.IsItemHovered() then ImGui.SetTooltip('Start rgmercs') end
            if ImGui.SmallButton('/rggroup') then mq.cmd('/rggroup') rgrunning = 2 end
            if ImGui.SmallButton('start a group') then runstuff = 1 end
            end
        ImGui.End()
    end
end

mq.imgui.init('RGGUI', RGGUI)

while werunning and openGUI do
    if rgrunning == 2 or switchmount==true or startup==true then
        if switchmount==true then mq.delay(2000) mq.cmd('/dismount') end
        mq.cmd('/rgstart') 
        mq.delay(6000)
        rgrunning = string.find(mq.TLO.Macro.Name() or '', 'RGMERC.mac')
        if rgrunning == nil then rgrunning = false else rgrunning = true end
        switchmount=false
        startup=false
    end
    if runstuff > 0 then
        if runstuff==1 then mygroupstart() end
        runstuff = 0
    end
    mq.delay(1000)
    rgrunning = string.find(mq.TLO.Macro.Name() or '', 'RGMERC.mac')
    if rgrunning == nil then rgrunning = false else rgrunning = true end
end